﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.3
@EndOfDesignText@
#Region  Service Attributes 
	#StartCommandReturnValue: android.app.Service.START_REDELIVER_INTENT
	#StartAtBoot: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private myftp As FTP
	Private FirstBo As Boolean
	Private uid As Int
	Private SaveDir As String
End Sub

Sub Service_Create
	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_ALWAYS  'we are handling it ourselves	
	'Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER
	'Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_WHEN_NEEDED
	Dim ctxt As JavaObject
	ctxt.InitializeContext
	uid = ctxt.RunMethodJO("getApplicationInfo", Null).GetField("uid")
	FirstBo = True
	SaveDir = File.DirRootExternal & "/test"
	If File.Exists(SaveDir,"")=False Then
		File.MakeDir(File.DirRootExternal,"test")
	End If
End Sub

Sub Service_Start (StartingIntent As Intent)	
	Service.StartForeground(uid,CreateNotification("...."))
	Dim L As Long
	If FirstBo = False Then 
		WriteLog("",False,"","Service.txt","now")
		myftp.Initialize("myftp", "myftpIP",21, "USER", "PASSWORD")
		myftp.PassiveMode = True
		myftp.TimeoutMs = 30
		myftp.SendCommand("NOOP","")
		Wait For myftp_CommandCompleted ( Command As String, Success As Boolean, ReplyCode As Int, ReplyString As String)		
		If ReplyCode = 200 Then
			DateTime.DateFormat = "yyyyMMddHHmmss"
			myftp.UploadFile(File.DirRootExternal & "/Test","service.txt",True,"service.txt")
			Log(Success)
		End If
	End If
	If FirstBo = True Then FirstBo = False
	StartServiceAt(Me, DateTime.Now + 30 * DateTime.TicksPerSecond, True)	
	'Sleep(1)
	'Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
	'Service.StopForeground(uid)
End Sub

Sub Service_Destroy

End Sub

Public Sub WriteLog(DirName As String,DateDirBol As Boolean,SubDirName As String,FileName As String,WriteStr As String)
	Try
		DateTime.Dateformat = "yyyyMM"
		Dim DateStr As String = ""
		If DirName <> "" Then DirName= "/" & DirName
		If DateDirBol=True Then DateStr = "/" & DateTime.Date(DateTime.Now)
		If SubDirName <> "" Then SubDirName= "/" & SubDirName
		Dim AllDirName As String = SaveDir  & DirName & DateStr & SubDirName
		If File.Exists(AllDirName,"") =False Then File.MakeDir(SaveDir,DirName & DateStr & SubDirName)
		Dim outStream As OutputStream
		Dim txtWrite As TextWriter
		outStream = File.OpenOutput(AllDirName,FileName,True)
		txtWrite.Initialize2(outStream,"BIG5")    '編碼
		DateTime.Dateformat = "yyyy/MM/dd HH:mm:ss"
		DateStr = DateTime.Date(DateTime.Now)
		txtWrite.WriteLine(DateStr & "," & WriteStr & Chr(13))
		txtWrite.Flush
		txtWrite.Close
		outStream.Close
	Catch
		Log("WriteLog")
	End Try
End Sub

Sub CreateNotification (Body As String) As Notification
	Dim notification As Notification
	notification.Initialize2(notification.IMPORTANCE_MIN)
	notification.Icon = "icon"
	notification.Sound = False
	notification.Vibrate = False
	notification.AutoCancel = True
	notification.SetInfo("Tracking location", Body,Main)
	notification.Notify(uid)
	Return notification	
End Sub