﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.5
@EndOfDesignText@
'Class module
'"BIG5"；中文編碼
'"UTF8"；萬國碼
'"Windows-1252"
'Ver 1.0.8
'PackageName="IoTLOG8Series"

Sub Class_Globals
	Private FileRBol As Boolean
	Private FileWBol As Boolean
	Private FileRWStr As String
	'Private DirRoot As String
	Private PackageName As String
	'Private Ref As Reflector
	Private SaveDir As String
	'Private Shared As String
	Private rp As RuntimePermissions
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	FileRBol=File.ExternalReadable
	FileWBol=File.ExternalWritable 
	If FileRBol=True Then
		FileRWStr=FileRWStr &"1"
	Else
		FileRWStr=FileRWStr &"0"
	End If
	If FileWBol=True Then
		FileRWStr=FileRWStr & "1"
	Else
		FileRWStr=FileRWStr & "0"
	End If
	PackageName="IoTLOG8Series"
	'PackageName=Ref.GetStaticField("anywheresoftware.b4a.BA", "packageName")
	'Log(rp.GetSafeDirDefaultExternal(""))
	
	SaveDir = File.DirRootExternal & "/" & PackageName
	If File.Exists(SaveDir,"")=False Then 
		File.MakeDir(File.DirRootExternal,PackageName)
		Filescan(File.DirRootExternal,"")
	End If
End Sub
Public Sub FileRW() As String
	Return FileRWStr
End Sub
Public Sub  MainSaveDir() As String
	Return SaveDir
End Sub
Public Sub test(DirName As String)
	If DirName <> "" Then DirName = "/" & DirName
	Dim AllDirName As String = SaveDir & DirName
	If File.Exists(AllDirName,"") = False Then File.MakeDir(SaveDir,DirName)
End Sub

Public Sub Exists(DirName As String,FileName As String) As Boolean
	If DirName <> "" Then DirName = "/" & DirName
	Dim AllDirName As String = SaveDir & DirName
	Return File.Exists(AllDirName,FileName)
End Sub

Public Sub ReadConfig(DirName As String,FileName As String,GetStr As String,DefaultVal As String) As String
	Try
		If FileRWStr="11" Then
			If DirName <> "" Then DirName = "/" & DirName
			Dim AllDirName As String = SaveDir & DirName
			If File.Exists(AllDirName,FileName) = False Then Return DefaultVal
			Dim ReadList As List
			ReadList.Initialize
			Dim InpStream As InputStream=File.OpenInput(AllDirName,FileName)
			Dim TxtRead As TextReader
			TxtRead.Initialize2(InpStream,"BIG5")    '編碼 
			ReadList=TxtRead.ReadList
			TxtRead.Close
			InpStream.Close
			If ReadList.Size = 0 Then Return DefaultVal
			Dim i As Int
			Dim SpReadList() As String
			For i = 0 To ReadList.Size - 1
				'SpReadList= Regex.Split("=",ReadList.Get(i))
				'If GetStr=SpReadList(0) Then Return SpReadList(1)
				If ReadList.Get(i) <> "" And GetStr.Length > 1 Then
				'If ReadList.Get(i) <> "" Then
					SpReadList= Regex.Split("=",ReadList.Get(i))
					If GetStr = SpReadList(0) Then
						If SpReadList.Length > 1 Then 
							Return SpReadList(1)
						Else
							Return DefaultVal
						End If
					End If
				End If
			Next
		End If
		Return DefaultVal
	Catch
		WriteLog("Error",True,"","FileIO.log",LastException.Message)
		Return DefaultVal
	End Try
	
End Sub
Public Sub SaveConfig(DirName As String,FileName As String,SaveStr As String, SaveValue As String) As Boolean 
	Try
		If FileRWStr="11" Then
			Dim Map1 As Map
			Map1.Initialize 
			Map1.Clear 
			If DirName <> "" Then  DirName = "/" & DirName
			Dim AllDirName As String=SaveDir & DirName
			If File.Exists(AllDirName,"") =False Then File.MakeDir(SaveDir,DirName)
			If File.Exists(AllDirName,FileName) = False Then 
				Map1.Put(SaveStr,SaveValue)
			Else
				Dim ReadList As List
				ReadList.Initialize 
				Dim InpStream As InputStream=File.OpenInput(AllDirName,FileName)
				Dim TxtRead As TextReader
				TxtRead.Initialize2(InpStream,"BIG5")    '編碼
				ReadList=TxtRead.ReadList
				TxtRead.Close
				InpStream.Close 
				If ReadList.Size <> 0 Then
					Dim i As Int 
					Dim SpReadList() As String
					For i = 0 To ReadList.Size - 1
						Dim S0 , S1 , GetStr As  String
						GetStr = ReadList.Get(i)
						If ReadList.Get(i) <> "" And GetStr.Length > 1 Then
							SpReadList = Regex.Split("=",ReadList.Get(i))
							S0=SpReadList(0)
							If  IsArray(SpReadList) = True Then
								S1 = SpReadList(1)
							Else	
								S1 = ""
							End If
							'Log(ReadList.Get(i))
							'Log(S0 & "," & S1)
							Map1.Put(S0,S1)
						End If
					Next
				End If
				Map1.Put(SaveStr,SaveValue)
			End If
			Dim outStream As OutputStream
			Dim txtWrite As TextWriter 
			outStream = File.OpenOutput(AllDirName,FileName,False)
			txtWrite.Initialize2(outStream,"BIG5")    '編碼
			For i = 0 To Map1.Size-1
				txtWrite.WriteLine(Map1.GetKeyAt(i)& "=" & Map1.GetValueAt(i) & Chr(13))
			Next 
			txtWrite.Flush
			txtWrite.Close 
			outStream.Close
			Filescan(AllDirName,FileName)
			Return True
		Else
			Return False
		End If
	Catch
		WriteLog("Error",True,"","FileIO.log",LastException.Message)
		Return False
	End Try
End Sub
Public Sub GetFileDatas(DirName As String,FileName As String) As List
	Dim ReadList As List
	ReadList.Initialize 
	Try
		If FileRWStr="11" Then
			If DirName <> "" Then  DirName = "/" & DirName
			Dim AllDirName As String = SaveDir & DirName
			If File.Exists(AllDirName,FileName) = False Then 
				ReadList.Initialize 
				Return ReadList
				'File.MakeDir(SaveDir,DirName)
			End If
			Dim InpStream As InputStream=File.OpenInput(AllDirName,FileName)
			Dim TxtRead As TextReader
			TxtRead.Initialize2(InpStream,"BIG5")    '編碼
			ReadList=TxtRead.ReadList
			TxtRead.Close
			InpStream.Close
			If ReadList.Size > 0 Then 
				Return ReadList
			Else
				ReadList.Initialize 
				Return ReadList
			End If
		Else
			ReadList.Initialize 
			Return ReadList
		End If
	Catch
		WriteLog("Error",True,"","FileIO.log",LastException.Message)
		ReadList.Initialize 
		Return ReadList
	End Try
End Sub
Public Sub GetListFiles(SourceDir As String ) As List
	Dim Files As List
	Files.Initialize
	'Log(SaveDir & "/" & SourceDir)
	If File.Exists(SaveDir & "/" & SourceDir ,"") = True Then
		Dim ListFiles,GetFiles As List
		Dim ShortFileName As String
		ListFiles.Initialize
		GetFiles.Initialize
		ListFiles = File.ListFiles(SaveDir & "/" & SourceDir)
		For i = 0 To ListFiles.Size - 1
			ShortFileName = ListFiles.Get(i)
			If File.IsDirectory(SaveDir & "/" & SourceDir , ListFiles.Get(i)) = False Then  
				If ShortFileName.IndexOf(".txt") = -1 Then
					GetFiles.Add(ListFiles.Get(i))
				End If
			End If
		Next
		Return GetFiles
	Else
		Return Files
	End If
End Sub

Public Sub GetVerStName(SourceDir As String) As List
	Dim VerStName As List 
	VerStName.Initialize
	Dim GetFiles As List 
	GetFiles.Initialize
	GetFiles = GetListFiles(SourceDir)
	If GetFiles.Size = 0 Then Return VerStName
	Dim StNum,StName,VerNB,VerSN,STNUMCHALL As String
	For i = 0 To GetFiles.Size - 1
		StNum = Main.FileM.ReadConfig ("DataBase/Station",GetFiles.Get(i),"STNUM","")
		StName = Main.FileM.ReadConfig ("DataBase/Station",GetFiles.Get(i),"STNAME","")
		VerNB = Main.FileM.ReadConfig ("DataBase/Station",GetFiles.Get(i),"VerNB","")
		VerSN = Main.FileM.ReadConfig ("DataBase/Station",GetFiles.Get(i),"PSensorType","")
		STNUMCHALL = Main.FileM.ReadConfig ("DataBase/Station",GetFiles.Get(i),"STNUMCHALL",":::")
		VerStName.Add (StNum & "," & StName & "," & VerNB & "," & VerSN & "," & STNUMCHALL)
	Next
	Return VerStName
End Sub

Public Sub GetStMsg(DirName As String,FileName As String) As List
	Dim ReadList As List
	ReadList.Initialize 
	Try
		If FileRWStr="11" Then
			If DirName <> "" Then  DirName = "/" & DirName
			Dim AllDirName As String = SaveDir & DirName
			If File.Exists(AllDirName,"") =False Then File.MakeDir(SaveDir,DirName)
			Dim InpStream As InputStream=File.OpenInput(AllDirName,FileName)
			Dim TxtRead As TextReader
			TxtRead.Initialize2(InpStream,"BIG5")    '編碼
			ReadList=TxtRead.ReadList
			TxtRead.Close
			InpStream.Close
			If ReadList.Size > 0 Then 
				Return ReadList
			Else
				ReadList.Initialize 
				Return ReadList
			End If
		Else
			ReadList.Initialize 
			Return ReadList
		End If
	Catch
		WriteLog("Error",True,"","FileIO.log",LastException.Message)
		ReadList.Initialize 
		Return ReadList
	End Try
End Sub
Public Sub SaveStName(DirName As String,FileName As String,SaveStr As String, SaveValue As String) As Boolean 
	Try 
		If FileRWStr="11" Then
			Dim Map1 As Map
			Map1.Initialize 
			Map1.Clear 
			If DirName <> "" Then  DirName = "/" & DirName
			Dim AllDirName As String=SaveDir & DirName
			If File.Exists(AllDirName,"") =False Then File.MakeDir(SaveDir,DirName)
			If File.Exists(AllDirName,FileName) = False Then 
				Map1.Put(SaveStr,SaveValue)
			Else
				Dim ReadList As List
				ReadList.Initialize 
				Dim InpStream As InputStream=File.OpenInput(AllDirName,FileName)
				Dim TxtRead As TextReader
				TxtRead.Initialize2(InpStream,"BIG5")    '編碼
				ReadList=TxtRead.ReadList
				TxtRead.Close
				InpStream.Close
				If ReadList.Size <> 0 Then
					Dim i As Int 
					Dim SpReadList() As String
					For i =0 To ReadList.Size - 1
						Dim S0 , S1 As  String
						SpReadList= Regex.Split(",",ReadList.Get(i))
						S0=SpReadList(0)
						Try
							S1=SpReadList(1)
						Catch
							S1=""
						End Try
						Map1.Put(S0,S1)
					Next
					Map1.Put(SaveStr,SaveValue)
				End If
			End If
			Dim outStream As OutputStream
			Dim txtWrite As TextWriter 
			outStream = File.OpenOutput(AllDirName,FileName,False)
			txtWrite.Initialize2(outStream,"BIG5")    '編碼
			For i = 0 To Map1.Size-1
				txtWrite.WriteLine(Map1.GetKeyAt(i)& "," & Map1.GetValueAt(i) & Chr(13))
			Next 
			txtWrite.Flush
			txtWrite.Close 
			outStream.Close
			Filescan(AllDirName,FileName)
			Return True
		Else
			Return False
		End If
	Catch
		WriteLog("Error",True,"","FileIO.log",LastException.Message)
		Return False
	End Try
End Sub
Public Sub WriteLog(DirName As String,DateDirBol As Boolean,SubDirName As String,FileName As String,WriteStr As String)
	Try
		DateTime.Dateformat = "yyyyMM"
		Dim DateStr As String = ""
		If DirName <> "" Then DirName= "/" & DirName
		If DateDirBol=True Then DateStr = "/" & DateTime.Date(DateTime.Now)
		If SubDirName <> "" Then SubDirName= "/" & SubDirName
		Dim AllDirName As String = SaveDir  & DirName & DateStr & SubDirName
		If File.Exists(AllDirName,"") =False Then File.MakeDir(SaveDir,DirName & DateStr & SubDirName)
		Dim outStream As OutputStream
		Dim txtWrite As TextWriter 
		outStream = File.OpenOutput(AllDirName,FileName,True)
		txtWrite.Initialize2(outStream,"BIG5")    '編碼
		DateTime.Dateformat = "yyyy/MM/dd HH:mm:ss"
		DateStr = DateTime.Date(DateTime.Now)
		txtWrite.WriteLine(DateStr & "," & WriteStr & Chr(13))
		txtWrite.Flush
		txtWrite.Close
		outStream.Close
		Filescan(AllDirName,FileName)
	Catch
		Log("WriteLog")
	End Try
End Sub
'可以取出檔名的迴圈： 例：FILENAME="C:\My Document\Ho-La\Monr1\GOODTIME\ab.exe"最後得到ab.exe
Public Sub GetFileName(FileName As String) As String
	Dim DirFile() As String=Regex.Split("/",FileName)
	If  DirFile(DirFile.Length-1).IndexOf(".")>-1 Then
		Return DirFile(DirFile.Length-1)
	Else
		Return ""
	End If
End Sub
'可以取出目錄的迴圈： 例：FILENAME="C:\My Document\Ho-La\Monr1\GOODTIME\ab.exe"最後得到C:\My Document\Ho-La\Monr1\GOODTIME
Public Sub GetPath(FileName As String) As String
	Dim ShortName As String
	Dim DirFile() As String=Regex.Split("/",FileName)
	If  DirFile(DirFile.Length-1).IndexOf(".")>-1 Then
		ShortName = DirFile(DirFile.Length-1)
	Else
		ShortName = ""
	End If
	Dim PathName As String
	PathName=FileName.Replace(ShortName,"")
	If PathName.SubString2(PathName.Length-1,PathName.Length) = "/" Then PathName=PathName.SubString2(0,PathName.Length-1)
	Return PathName
End Sub
Public Sub BufferFileNameData(SaveDirName As String,SaveStNumName As String, SubName As String, SaveDataList As List) As String
	DoEvents
	Dim i As Int
	If SaveDirName <> "" Then SaveDirName = "/" & SaveDirName
	Dim SaveAllDirName As String = SaveDir & SaveDirName
	If File.Exists(SaveAllDirName,"") = False Then File.MakeDir(SaveDir,SaveDirName)
	Dim ShortFileName As String
	Dim RBol As Boolean = False
	'For i=0 To 999
	'	If File.Exists(SaveAllDirName,SaveStNumName & "_" & NumberFormat(i,3,0) & SubName) = False Then 
	'		ShortFileName=SaveStNumName & "_" & NumberFormat(i,3,0) & SubName
	'		Exit
	'	End If
	'	If i = 999 Then  RBol = True 
	'Next
	'If RBol = True Then
	'	For i = 0 To 999
	'		File.Delete(SaveAllDirName,SaveStNumName & "_" & NumberFormat(i,3,0) & SubName)
	'	Next 
	'	For i=0 To 999
	'		If File.Exists(SaveAllDirName,SaveStNumName & "_" & NumberFormat(i,3,0) & SubName) = False Then 
	'			ShortFileName=SaveStNumName & "_" & NumberFormat(i,3,0) & SubName
	'			Exit
	'		End If
	'	Next
	'End If
	ShortFileName = SaveStNumName & SubName
	Dim DataBufList As List
	DataBufList.Initialize 
	For i = 0 To SaveDataList.Size -1
		Dim SaveData As String
		SaveData = SaveDataList.Get(i)
		DataBufList.Add(SaveData.Length & Chr(13))
		DataBufList.Add(SaveData & Chr(13))
	Next
	Log(File.Exists(SaveAllDirName,""))
	Dim outStream As OutputStream
	Dim txtWrite As TextWriter
	Try
		outStream = File.OpenOutput(SaveAllDirName,ShortFileName,False)
		txtWrite.Initialize2(outStream,"BIG5")    '編碼
		For i = 0 To DataBufList.Size - 1
			DoEvents
			txtWrite.WriteLine(DataBufList.Get(i))
		Next
		'txtWrite.WriteList(DataBufList)
		txtWrite.Flush
		txtWrite.Close
		outStream.Close
		Filescan(SaveAllDirName,ShortFileName)
		Return SaveAllDirName & "/" & ShortFileName
	Catch
		WriteLog("Error",True,"","FileIO.log",LastException.Message)
		Log(LastException)
	End Try

End Sub
Public Sub BufferFileNameData2(SaveDirName As String,SaveStNumName As String, SubName As String, SaveDataMap As Map) As String
	DoEvents
	Dim i As Int
	If SaveDirName <> "" Then SaveDirName = "/" & SaveDirName
	Dim SaveAllDirName As String = SaveDir & SaveDirName
	If File.Exists(SaveAllDirName,"") = False Then File.MakeDir(SaveDir,SaveDirName)
	Dim ShortFileName As String
	'Dim RBol As Boolean = False
	'For i=0 To 999
	'	If File.Exists(SaveAllDirName,SaveStNumName & "_" & NumberFormat(i,3,0) & SubName) = False Then 
	'		ShortFileName=SaveStNumName & "_" & NumberFormat(i,3,0) & SubName
	'		Exit
	'	End If
	'	If i = 999 Then  RBol = True 
	'Next
	'If RBol = True Then
	'	For i = 0 To 999
	'		File.Delete(SaveAllDirName,SaveStNumName & "_" & NumberFormat(i,3,0) & SubName)
	'	Next 
	'	For i=0 To 999
	'		If File.Exists(SaveAllDirName,SaveStNumName & "_" & NumberFormat(i,3,0) & SubName) = False Then 
	'			ShortFileName=SaveStNumName & "_" & NumberFormat(i,3,0) & SubName
	'			Exit
	'		End If
	'	Next
	'End If
	ShortFileName = SaveStNumName & SubName
	Dim DataBufList As List
	DataBufList.Initialize 
	For i = 0 To SaveDataMap.Size - 1
		Dim SaveData As String
		SaveData = SaveDataMap.GetValueAt(i)
		DataBufList.Add(SaveDataMap.GetKeyAt(i) & "," & SaveData.Length & Chr(13))
		DataBufList.Add(SaveData & Chr(13))
	Next 
	Dim outStream As OutputStream
	Dim txtWrite As TextWriter
	outStream = File.OpenOutput(SaveAllDirName,ShortFileName,False)
	txtWrite.Initialize2(outStream,"BIG5")    '編碼
	For i = 0 To DataBufList.Size - 1
		DoEvents
		txtWrite.WriteLine(DataBufList.Get(i))
	Next
	'txtWrite.WriteList(DataBufList)
	txtWrite.Flush
	txtWrite.Close
	outStream.Close
	Filescan(SaveAllDirName,ShortFileName)
	Return SaveAllDirName & "/" & ShortFileName		
End Sub

Public Sub FileNameData(SaveDirName As String,SaveStNumName As String, SubName As String, SaveDataList As List,HandDataBol As Boolean ) As String
	DoEvents
	If SaveDataList.Size < 0 Then Return ""
	Dim i As Int
	Dim DateFormat As String
	DateFormat = DateTime.DateFormat
	DateTime.DateFormat = "yyyyMM"
	If HandDataBol = True Then
		If SaveDirName <> "" Then SaveDirName = "/" & SaveDirName & "/" & DateTime.Date(DateTime.Now)
	Else
		If SaveDirName <> "" Then SaveDirName = "/" & SaveDirName & "/" & DateTime.Date(DateTime.Now)
	End If

	Dim SaveAllDirName As String = SaveDir & SaveDirName
	If File.Exists(SaveAllDirName,"") = False Then File.MakeDir(SaveDir,SaveDirName)
	Log(SaveAllDirName)
	Dim ShortFileName As String = SaveStNumName	
	DateTime.DateFormat = "yyyyMMdd"
	If HandDataBol = True Then ShortFileName = SaveStNumName & "_" & DateTime.Date(DateTime.Now)
	DateTime.DateFormat = DateFormat
	Dim RBol As Boolean = False
	For i = 0 To 999
		If File.Exists(SaveAllDirName,ShortFileName & "_" & NumberFormat(i,3,0) & SubName) = False Then 
			ShortFileName=ShortFileName & "_" & NumberFormat(i,3,0) & SubName
			Exit
		End If
		If i = 999 Then  RBol = True 
	Next
	If RBol = True Then
		For i = 0 To 999
			File.Delete(SaveAllDirName,ShortFileName & "_" & NumberFormat(i,3,0) & SubName)
		Next 
		For i=0 To 999
			If File.Exists(SaveAllDirName,ShortFileName & "_" & NumberFormat(i,3,0) & SubName) = False Then 
				ShortFileName=ShortFileName & "_" & NumberFormat(i,3,0) & SubName
				Exit
			End If
		Next
	End If
	Dim i As Int 	
	Dim DataList As List 
  	DataList.Initialize
 	For i = 0 To SaveDataList.Size - 1 
    		DataList.Add(SaveDataList.Get(i) & Chr(13))
	Next
	'Dim t As Long
	't=DateTime.now
	Dim outStream As OutputStream
	Dim txtWrite As TextWriter
	outStream = File.OpenOutput(SaveAllDirName,ShortFileName,True)
	txtWrite.Initialize2(outStream,"BIG5")    '編碼
	For i = 0 To DataList.Size - 1
		DoEvents
		'Log(DataList.Get(i))
		txtWrite.Writeline(DataList.Get(i))
	Next
	'txtWrite.WriteList(DataList)
	txtWrite.Flush
	txtWrite.Close
	outStream.Close
	'Log(DateTime.now-t)
	Filescan(SaveAllDirName,ShortFileName)
	Return SaveAllDirName & "/" & ShortFileName
End Sub

Public Sub GetFileNameData(SaveDirName As String,SaveStNumName As String, SubName As String,HandDataBol As Boolean ) As String
	DoEvents
	Dim i As Int
	If SaveDirName <> "" Then SaveDirName = "/" & SaveDirName
	Dim SaveAllDirName As String = SaveDir & SaveDirName
	If File.Exists(SaveAllDirName,"") = False Then File.MakeDir(SaveDir,SaveDirName)
	Log(SaveAllDirName)
	Dim ShortFileName As String = SaveStNumName
	If HandDataBol = True Then
		DateTime.DateFormat = "yyyyMMdd"
		ShortFileName=SaveStNumName & "_" & DateTime.Date(DateTime.Now)
	End If
	Dim RBol As Boolean = False
	For i=0 To 999
		If File.Exists(SaveAllDirName,ShortFileName & "_" & NumberFormat(i,3,0) & SubName) = False Then
			ShortFileName=ShortFileName & "_" & NumberFormat(i,3,0) & SubName
			Exit
		End If
		If i = 999 Then RBol = True
	Next
	If RBol = True Then
		For i = 0 To 999
			File.Delete(SaveAllDirName,ShortFileName & "_" & NumberFormat(i,3,0) & SubName)
		Next
		For i=0 To 999
			If File.Exists(SaveAllDirName,ShortFileName & "_" & NumberFormat(i,3,0) & SubName) = False Then
				ShortFileName=ShortFileName & "_" & NumberFormat(i,3,0) & SubName
				Exit
			End If
		Next
	End If
	Return SaveAllDirName & "," & ShortFileName
End Sub


Public Sub SaveFileNameData(SaveAllDirName As String,ShortFileName As String, SaveDataList As List)
	DoEvents
	If SaveDataList.Size < 0 Then Return
	Dim i As Int
	Dim DataList As List
	DataList.Initialize
	For i = 0 To SaveDataList.Size - 1
		DataList.Add(SaveDataList.Get(i) & Chr(13))
	Next
	Dim outStream As OutputStream
	Dim txtWrite As TextWriter
	outStream = File.OpenOutput(SaveAllDirName,ShortFileName,True)
	txtWrite.Initialize2(outStream,"BIG5")    '編碼
	For i = 0 To DataList.Size - 1
		DoEvents
		txtWrite.Writeline(DataList.Get(i))
	Next
	'txtWrite.WriteList(DataList)
	txtWrite.Flush
	txtWrite.Close
	outStream.Close
	Filescan(SaveAllDirName,ShortFileName)
End Sub

Public Sub Trans2Month(SourceFileName As String,SaveDirName As String, SaveStNumName As String, SubName As String, KillSourceFileName As Boolean)
	If SaveDirName <> "" Then SaveDirName = "/" & SaveDirName
	'Dim UByteC As ByteConverter 
	Dim SaveAllDirName As String = SaveDir & SaveDirName
	Dim ShortSourceFileName As String=GetFileName(SourceFileName)
	Dim PathSourceFileName As String=GetPath(SourceFileName)
	If File.Exists(SaveAllDirName,"") = False Then File.MakeDir(SaveDir,SaveDirName)
	Dim ReadList As List
	ReadList.Initialize 
	Dim InpStream As InputStream=File.OpenInput(PathSourceFileName,ShortSourceFileName)
	Dim TxtRead As TextReader
	TxtRead.Initialize2(InpStream,"BIG5")    '編碼
	ReadList=TxtRead.ReadList
	TxtRead.Close
	ReadList.Sort(True)
	Dim Seclng As Long 
	Dim Sp() As String
	Dim TempYYYYMM,YYYYMM As String
	Dim i As Int
	Dim DataList As List
	DataList.Initialize
	'Dim a As List
	'a.Initialize 
	For i= 0 To ReadList.Size - 1
		'a.Add( UByteC.HexFromBytes ( UByteC.StringToBytes(ReadList.Get(i),"BIG5")))
		DoEvents
		Sp = Regex.Split(",",ReadList.Get(i))
		DateTime.DateFormat="yyyy/MM/dd HH:mm:ss"
		Seclng = DateTime.DateParse(Sp(0))
		DateTime.DateFormat="yyyyMM"
		YYYYMM = DateTime.Date(Seclng)
		If i=0 Then TempYYYYMM=YYYYMM
		If TempYYYYMM=YYYYMM Then
			DataList.Add(ReadList.Get(i))	
		Else
			'Log(YYYYMM & "," & Datalist.Get(0))
			Trans2MonthAddOf(SaveAllDirName,TempYYYYMM ,SaveStNumName & SubName , DataList)
			If i= ReadList.Size-1 Then Exit 
			DataList.Initialize
			DataList.Add(ReadList.Get(i))
			TempYYYYMM=YYYYMM
		End If
		If i= ReadList.Size - 1 Then 
			Trans2MonthAddOf(SaveAllDirName,TempYYYYMM,SaveStNumName & SubName , DataList)
		End If
		DoEvents
	Next
End Sub

Public Sub Trans2MonthL(readList As List,SaveDirName As String, SaveStNumName As String, SubName As String, KillSourceFileName As Boolean)
	If SaveDirName <> "" Then SaveDirName = "/" & SaveDirName
	'Dim UByteC As ByteConverter 
	Dim SaveAllDirName As String = SaveDir & SaveDirName
	readList.Sort(True)
	Dim Seclng As Long 
	Dim Sp() As String
	Dim TempYYYYMM,YYYYMM As String
	Dim i As Int
	Dim DataList As List
	DataList.Initialize
	'Dim a As List
	'a.Initialize 
	For i= 0 To readList.Size - 1
		'a.Add( UByteC.HexFromBytes ( UByteC.StringToBytes(ReadList.Get(i),"BIG5")))
		DoEvents
		Sp = Regex.Split(",",readList.Get(i))
		DateTime.DateFormat="yyyy/MM/dd HH:mm:ss"
		Seclng = DateTime.DateParse(Sp(0))
		DateTime.DateFormat="yyyyMM"
		YYYYMM = DateTime.Date(Seclng)
		If i=0 Then TempYYYYMM=YYYYMM
		If TempYYYYMM=YYYYMM Then
			DataList.Add(readList.Get(i))	
		Else
			'Log(YYYYMM & "," & Datalist.Get(0))
			Trans2MonthAddOf(SaveAllDirName,TempYYYYMM ,SaveStNumName & SubName , DataList)
			If i= readList.Size-1 Then Exit 
			DataList.Initialize
			DataList.Add(readList.Get(i))
			TempYYYYMM=YYYYMM
		End If
		If i= readList.Size - 1 Then 
			Trans2MonthAddOf(SaveAllDirName,TempYYYYMM,SaveStNumName & SubName , DataList)
		End If
		DoEvents
	Next
End Sub

Private Sub Trans2MonthAddOf(ParentName As String,SaveDirName As String ,ShortFileName As String, TempDataList As List)
	Dim i As Int 
	'Dim UByteC As ByteConverter 
	'For i = 0 To TempDataList.Size - 1
	'	Log(UByteC.HexFromBytes (UByteC.StringToBytes(TempDataList.Get(i),"BIG5")))
	'Next
	'Return
	Dim T1,T As Long
	T1 = DateTime.Now
	If SaveDirName <> "" Then SaveDirName = "/" & SaveDirName
	Dim AllDirName As String = ParentName & SaveDirName
	If File.Exists(AllDirName,"") = False Then File.MakeDir(ParentName,SaveDirName)
	If File.Exists(AllDirName,ShortFileName) = True Then
		Dim ReadList As List
		ReadList.Initialize
		Dim InpStream As InputStream = File.OpenInput(AllDirName,ShortFileName)
		Dim TxtRead As TextReader
		TxtRead.Initialize2(InpStream,"BIG5")    '編碼
		ReadList = TxtRead.ReadList
		TxtRead.Close
		InpStream.Close 
		TempDataList.AddAll(ReadList)
		TempDataList.Sort(True)
	End If
	Dim WOT As WangOfTools
	TempDataList = WOT.ListLinkedHashSet(TempDataList)
	Dim outStream As OutputStream
	Dim txtWrite As TextWriter
	Dim DateStr,DateDataStr As String
	outStream = File.OpenOutput(AllDirName,ShortFileName,False)
	txtWrite.Initialize2(outStream,"BIG5")    '編碼
	For i = 0 To TempDataList.Size - 1
		DoEvents
		'txtWrite.Writeline(TempDataList.Get(i) & Chr(13))
		DateDataStr = TempDataList.Get(i)
		If i = 0 Then
			txtWrite.Writeline(DateDataStr & Chr(13))
			DateStr=DateDataStr.SubString2(0,19)
		Else
			If DateDataStr.IndexOf(DateStr) = -1 Then
				txtWrite.Writeline(DateDataStr & Chr(13))
				DateStr = DateDataStr.SubString2(0,19)
			End If
		End If				
	Next
	'txtWrite.WriteList(TempDataList)
	txtWrite.Flush
	txtWrite.Close 
	outStream.Close
	Filescan(AllDirName,ShortFileName) 
	T = DateTime.now - T1
	Log("Trans2MonthAddOfMileSec:" & t)


'	Dim DateStr,DateDataStr As String
'	Dim outStream As OutputStream
'	Dim txtWrite As TextWriter 
'	outStream = File.OpenOutput(AllDirName,ShortFileName,False)
'	txtWrite.Initialize2(outStream,"BIG5")    '編碼
'	For i = 0 To TempDataList.Size - 1
'		DoEvents
'		DateDataStr = TempDataList.Get(i)
'		DoEvents
'		If i = 0 Then
'			txtWrite.Writeline(DateDataStr)
'			DateStr=DateDataStr.SubString2(0,19) & Chr(13))
'		Else
'			If DateDataStr.IndexOf(DateStr) = -1 Then
'				txtWrite.Writeline(DateDataStr & Chr(13))
'				DateStr = DateDataStr.SubString2(0,19)
'			End If
'		End If				
'	Next
'	txtWrite.Flush
'	txtWrite.Close 
'	outStream.Close
'	Filescan(AllDirName,ShortFileName)
'	Log(DateTime.now - t)
	
	
'	Dim SaveDataList As List
'	SaveDataList.Initialize 
'	If File.Exists(AllDirName,ShortFileName) = True Then
'		Dim ReadList As List
'		ReadList.Initialize
'		Dim t As Long
'		t = DateTime.now
'		Dim InpStream As InputStream = File.OpenInput(AllDirName,ShortFileName)
'		Dim TxtRead As TextReader
'		TxtRead.Initialize2(InpStream,"BIG5")    '編碼
'		ReadList = TxtRead.ReadList
'		TxtRead.Close
'		InpStream.Close 
'		TempDataList.AddAll(ReadList)
'		TempDataList.Sort(True)
'		Log("L:" & TempDataList.Size)
'		Log(DateTime.now - t)
'		Dim DateStr,DateDataStr As String
'		For i= 0 To TempDataList.Size - 1
'			DoEvents
'			DateDataStr = TempDataList.Get(i)
'			If i = 0 Then 
'				SaveDataList.Add(DateDataStr & Chr(13))
'				DateStr=DateDataStr.SubString2(0,19)
'				'Log(DateDataStr)
'			Else
'				If DateDataStr.IndexOf(DateStr) = -1 Then
'					SaveDataList.Add(DateDataStr & Chr(13))
'					DateStr = DateDataStr.SubString2(0,19)
'					'Log(DateDataStr)
'				End If
'			End If
'		Next
'	Else
'		For i= 0 To TempDataList.Size - 1
'			DoEvents
'			SaveDataList.Add(TempDataList.Get(i) & Chr(13))
'		Next 
'	End If
'	Dim outStream As OutputStream
'	Dim txtWrite As TextWriter 
'	outStream = File.OpenOutput(AllDirName,ShortFileName,False)
'	txtWrite.Initialize2(outStream,"BIG5")    '編碼
'	'For i = 0 To SaveDataList.Size - 1
'	'	DoEvents
'	'	txtWrite.Writeline(SaveDataList.Get(i))
'	'Next
'	txtWrite.WriteList(SaveDataList)
'	txtWrite.Flush
'	txtWrite.Close 
'	outStream.Close
'	Filescan(AllDirName,ShortFileName) 
End Sub
Public Sub Data2ASCII(SourceDirName As String, SaveDirName As String,DataDate As String, StNum As String, SubName As String) As Boolean 
	Try
		Dim i As Int
		If SourceDirName <> "" Then SourceDirName = "/" & SourceDirName
		Dim SourceAllDirName As String = SaveDir & SourceDirName
		DateTime.dateformat="yyyy/MM/dd HH:mm:ss"
		Dim DataSeclng As Long=DateTime.DateParse(DataDate)
		DateTime.dateformat="yyyyMM"
		Dim yyyyMM As String = DateTime.Date(DataSeclng)
		SourceAllDirName=SourceAllDirName & "/" & yyyyMM
		If File.Exists(SourceAllDirName,StNum & SubName)=False Then Return False '"該月無資料"
		Dim FDataList As List
		FDataList.Initialize 
		Dim InpStream As InputStream=File.OpenInput(SourceAllDirName,StNum & SubName)
		Dim TxtRead As TextReader
		TxtRead.Initialize2(InpStream,"BIG5")    '編碼
		FDataList=TxtRead.ReadList
		TxtRead.Close
		InpStream.Close
		FDataList.Sort(True)
		Dim LDataSeclng As Long=DateTime.Add(DataSeclng,0,-1,0)
		Dim LyyyyMM As String = DateTime.Date(LDataSeclng)
		Dim LDays As String=NumberFormat( DateUtils.NumberOfDaysInMonth(DateTime.GetMonth(LDataSeclng), DateTime.GetYear(LDataSeclng)),2,0)
		Dim LFDataList As List
		Dim ReadStr As String
		LFDataList.Initialize
		'↓找出上個月~23:00後與這個月的 01 00:00:00的資料
		If File.Exists(SaveDir & SaveDirName & "/" & LyyyyMM,StNum & SubName)=True Then
			Dim ReadList As List
			Dim InpStream As InputStream=File.OpenInput(SaveDir & SaveDirName & "/" & LyyyyMM,StNum & SubName)
			Dim TxtRead As TextReader
			ReadList.Initialize 
			TxtRead.Initialize2(InpStream,"BIG5")    '編碼
			ReadList=TxtRead.ReadList
			TxtRead.Close
			InpStream.Close 
			If ReadList.Size > 0 Then
				For i = ReadList.Size-1 To 0 Step -1
					DoEvents
					ReadStr=ReadList.Get(i) 
					'Log(ReadStr.SubString2(8,13) & "," & LDays & " 23")
					If ReadStr.SubString2(8,13) = LDays & " 23" Then
						LFDataList.Add(ReadStr)
					Else
						Exit 
					End If
				Next
			End If
		End If
		ReadStr=FDataList.Get(0)
		If ReadStr.IndexOf("01 00:00:00") > -1 Then LFDataList.Add(ReadStr)
		LFDataList.Sort(True)
		Dim Bol As Boolean = Ch2Ascii(SaveDirName, DataDate, LFDataList , FDataList, StNum)
		Return Bol
	Catch
		WriteLog("Error",True,"","FileIO.log",LastException.Message)
		'Return "轉換失敗"
		Return False
	End Try
End Sub
Private Sub Ch2Ascii(SaveDirName As String, DataDate As String, LFDataList As List , FDataList As List, StNum As String) As Boolean 
	Try
		DateTime.dateformat="yyyy/MM/dd HH:mm:ss"
		Dim DataSeclng As Long=DateTime.DateParse(DataDate)
		DateTime.dateformat="yyyyMM"
		Dim yyyyMM As String = DateTime.Date(DataSeclng)
		DateTime.dateformat="yyyy/MM/dd HH:mm:ss"
		Dim i , j  As Int
		Dim Days As Int = DateUtils.NumberOfDaysInMonth(DateTime.GetMonth(DataSeclng), DateTime.GetYear(DataSeclng))
		Dim DHData(Days+1, 24) As String
		Dim SpData() As String
		 '↓記算這個月每日每小時的資料和與個數
       	For i = 0 To FDataList.size - 1
			DoEvents
			'Dim Data As String = FDataList.Get(i)
			SpData = Regex.Split(",",FDataList.Get(i))
			Dim Seclng As Long=DateTime.DateParse(SpData(0))
			Dim DD As Int = DateTime.GetDayOfMonth(Seclng)
			Dim HH As Int = DateTime.GetHour(Seclng)
			If DHData(DD, HH) = "" Then
				DHData(DD, HH) = SpData(1) & ",1"
			Else
				Dim SpDHData() As String = Regex.Split(",",DHData(DD,HH))
				SpDHData(0) = SpDHData(0) + SpData(1)
				SpDHData(1) = SpDHData(1) + 1
				DHData(DD,HH) = SpDHData(0) & "," & SpDHData(1)
          	End If
		Next
		'↑
		'↓記算這個月每日每小時的平均值
		For i = 0 To Days
			For j = 0 To 23
				DoEvents
				If DHData(i, j)<>"" Then 
					SpData = Regex.Split(",",DHData(i, j))
					If SpData(0) <> 0 Then
						Dim AvgData As String
						AvgData = ModCheck.NumberFormatStr(SpData(0) / SpData(1),1,2)						
						DHData(i, j)=ModCheck.FixString(AvgData,6," ",True,False)
					Else
                 		DHData(i, j) = "      "
             		End If
				Else
					DHData(i, j) = "      "
				End If
			Next
       Next
		'↑
		'↓計算上個月~23:00後與這個月的 01 00:00:00的資料和與個數
		Dim FirstData As String = ""
		If LFDataList.Size > 0 Then
			For i=0 To LFDataList.Size-1
				DoEvents
				SpData = Regex.Split(",",LFDataList.Get(i))
				If FirstData = "" Then
               		FirstData = SpData(1) & ",1"
            	Else
                   	Dim SpFirstData() As String =  Regex.Split(",",FirstData)
                   	SpFirstData(0) = SpFirstData(0) + SpData(1)
					SpFirstData(1) = SpFirstData(1) + 1
                   	FirstData = SpFirstData(0) & "," & SpFirstData(1)
               End If
			Next
		End If
		'↑
		'↓計算上個月~23:00後與這個月的 01 00:00:00的平均值
       If FirstData <> "" Then
        	SpData =  Regex.Split(",",FirstData)
            If SpData(0) <> 0 Then
				Dim AvgData As String
				AvgData = ModCheck.NumberFormatStr(SpData(0) / SpData(1),1,2)				
				FirstData=ModCheck.FixString(AvgData,6," ",True,False)
				'Log(FirstData)
			Else
                FirstData = "      "
            End If
        Else
            FirstData ="      "
        End If
		'↑
		'資料排列 每天(排)的第一筆為前1天 23:00~ 23:59的資料 除了第一天的第一筆有 01 00:00:00的資料
        '23 00 01 02 03 ~ 22  
        '~
        '23 00 01 02 03 ~ 22
        '23 
        Dim DayDataList As List
		DayDataList.Initialize 
		For i = 1 To Days
			DoEvents
			Dim Data As String = ""
			Data = StNum & yyyyMM &  NumberFormat(i,2,0)
			If i = 1 Then
            	Data = Data & FirstData
           	Else
            	Data = Data & DHData(i - 1, 23)
          	End If
			For j = 0 To 22
           		Data = Data & DHData(i, j)
          	Next
			DayDataList.Add(Data & Chr(13))
		Next
		DateTime.dateformat="yyyyMM"
		Dim NDataSeclng As Long=DateTime.Add(DataSeclng,0,1,0)
		Dim NyyyyMM As String = DateTime.Date(NDataSeclng)
		DayDataList.Add(StNum & NyyyyMM & "01" & DHData(Days, 23) & Chr(13))
		Dim SubMonth() As String =Array As String("A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L")
		Dim SubName As String =yyyyMM.SubString2(2,4) & SubMonth(yyyyMM.SubString2(4,yyyyMM.Length)-1)   
		If SaveDirName <> "" Then SaveDirName = "/" & SaveDirName
		Dim SaveAllDirName As String = SaveDir & SaveDirName
		SaveAllDirName=SaveAllDirName & "/" & yyyyMM
		If File.Exists(SaveAllDirName,"")=False Then File.MakeDir(SaveDir & SaveDirName,yyyyMM)
		Dim outStream As OutputStream
		Dim txtWrite As TextWriter 
		outStream = File.OpenOutput(SaveAllDirName,StNum & "." & SubName,False)
		txtWrite.Initialize2(outStream,"BIG5")    '編碼
		For i = 0 To DayDataList.Size - 1
			DoEvents
			txtWrite.WriteLine(DayDataList.Get(i))
		Next
		'txtWrite.WriteList(DayDataList)
		txtWrite.Flush
		txtWrite.Close 
		outStream.Close
		Filescan(SaveAllDirName,StNum & "." & SubName)
		Return True
	Catch
		WriteLog("Error",True,"","FileIO.log",LastException.Message)
		'Return "轉換失敗"
		Return False
	End Try
End Sub
Public Sub Data2ASCIIRain(SourceDirName As String, SaveDirName As String,DataDate As String,StNum As String, SubName As String) As Boolean 
	Dim OLDDateFormat As String = DateTime.DateFormat
	Dim OLDTimeFormat As String = DateTime.TimeFormat
	Try
		Dim i As Int
		If SourceDirName <> "" Then SourceDirName = "/" & SourceDirName
		Dim SourceAllDirName As String = SaveDir & SourceDirName
		DateTime.dateformat="yyyy/MM/dd HH:mm:ss"
		Dim DataSeclng As Long=DateTime.DateParse(DataDate)
		DateTime.dateformat="yyyyMM"
		Dim yyyyMM As String = DateTime.Date(DataSeclng)
		SourceAllDirName=SourceAllDirName & "/" & yyyyMM
		If File.Exists(SourceAllDirName,StNum & SubName)=False Then Return False'"該月無資料"
		Dim DataList As List
		DataList.Initialize 
		Dim InpStream As InputStream=File.OpenInput(SourceAllDirName,StNum & SubName)
		Dim TxtRead As TextReader
		TxtRead.Initialize2(InpStream,"BIG5")    '編碼
		DataList=TxtRead.ReadList
		TxtRead.Close
		InpStream.Close
		DataList.Sort(True)
		If DataList.Size > 0 Then
			Dim RainDataList As List
			RainDataList.Initialize 
			For i = 0 To DataList.Size - 1
				Dim SpData() As String = Regex.Split(",",DataList.Get(i))
				DateTime.DateFormat="yyyy/MM/dd HH:mm:ss"
				Dim DateSeclng As Long = DateTime.DateParse(SpData(0))
				DateTime.DateFormat="yyMMddHHmm"
				RainDataList.Add (DateTime.Date(DateSeclng) & Chr(13))
			Next
			If SaveDirName <> "" Then SaveDirName = "/" & SaveDirName
			Dim SaveAllDirName As String = SaveDir & SaveDirName
			SaveAllDirName=SaveAllDirName & "/" & yyyyMM
			If File.Exists(SaveAllDirName,"") = False Then File.MakeDir(SaveDir & SaveDirName,yyyyMM)
			Dim outStream As OutputStream
			Dim txtWrite As TextWriter 
			outStream = File.OpenOutput(SaveAllDirName,StNum & ".DAT" ,False)
			txtWrite.Initialize2(outStream,"BIG5")    '編碼
			For i = 0 To RainDataList.Size - 1
				DoEvents
				txtWrite.Writeline(RainDataList.Get(i))
			Next
			'txtWrite.WriteList(RainDataList)
			txtWrite.Flush
			txtWrite.Close 
			outStream.Close
			Filescan(SaveAllDirName,StNum & ".DAT")
		End If
		DateTime.DateFormat = OLDDateFormat
		DateTime.TimeFormat = OLDTimeFormat
		Return True
	Catch
		WriteLog("Error",True,"","FileIO.log",LastException.Message)
		DateTime.DateFormat = OLDDateFormat
		DateTime.TimeFormat = OLDTimeFormat
		Return False
	End Try
End Sub
Public Sub Filescan(dir As String,filename As String)	'快速顯示
	Try
		Dim context As JavaObject
		context = context.InitializeStatic("anywheresoftware.b4a.BA").GetField("applicationContext")
    	Dim paths() As String = Array As String(File.Combine(dir,filename)) 'files to scan
    	Dim mediaScanner As JavaObject
    	mediaScanner.InitializeStatic("android.media.MediaScannerConnection")
    	mediaScanner.RunMethod("scanFile", Array As Object(context, paths, Null, Null))	
	Catch
		WriteLog("Error",True,"","FileIO.log",LastException.Message)
		Log(LastException)
	End Try
End Sub
Public Sub GetSearchSt(SourceDir As String,Search As String) As List
	Dim StFileList As List
	StFileList.Initialize
	Dim StSearchList As List
	StSearchList.Initialize
	StFileList = GetListFiles(SourceDir)
	If StFileList.Size = 0 Then Return StSearchList
	Dim St As String = ""
	For i = 0 To StFileList.Size - 1
		St = Main.FileM.ReadConfig ("DataBase/Station",StFileList.Get(i),"STNUM","") & "," & _
			 Main.FileM.ReadConfig ("DataBase/Station",StFileList.Get(i),"STNAME","")
		If St.IndexOf(Search)>=0 Then StSearchList.Add(St)
	Next
	StSearchList.Sort(True) 
	Return StSearchList
End Sub
Public Sub GetSearchStDevice(SourceDir As String,Search As String) As List
	Dim StFileList As List
	StFileList.Initialize
	Dim StSearchList As List
	StSearchList.Initialize
	StFileList = GetListFiles(SourceDir)
	If StFileList.Size = 0 Then Return StSearchList
	Dim St As String = ""
	For i = 0 To StFileList.Size - 1
		St = Main.FileM.ReadConfig ("DataBase/Station",StFileList.Get(i),"STNUM","") & "," & _
			 Main.FileM.ReadConfig ("DataBase/Station",StFileList.Get(i),"STSN","")
		If St.IndexOf(Search)>=0 Then StSearchList.Add(St)
	Next
	StSearchList.Sort(True) 
	Return StSearchList
End Sub
Public Sub Export2File(SaveDirName As String,SaveName As String, SubName As String, SaveDataList As List)
	DoEvents
	Dim i As Int
	If SaveDirName <> "" Then SaveDirName = "/" & SaveDirName
	Dim SaveAllDirName As String = SaveDir & SaveDirName
	If File.Exists(SaveAllDirName,"") = False Then File.MakeDir(SaveDir,SaveDirName)
	Dim ShortFileName As String
	Dim DateFormat As String = DateTime.DateFormat
	Dim TimeFormat As String = DateTime.TimeFormat
	DateTime.DateFormat = "yyyyMMddHHmm"
	Dim NowStr As String = DateTime.Date(DateTime.Now)
	DateTime.DateFormat = DateFormat
	DateTime.TimeFormat = TimeFormat 
	ShortFileName = SaveName & "_" & NowStr & SubName
	Dim DataBufList As List
	DataBufList.Initialize 
	For i = 0 To SaveDataList.Size - 1
		Dim SaveData As String
		SaveData = SaveDataList.Get(i)
		DataBufList.Add(SaveData & Chr(13))
	Next 
	Dim outStream As OutputStream
	Dim txtWrite As TextWriter
	outStream = File.OpenOutput(SaveAllDirName,ShortFileName,False)
	txtWrite.Initialize2(outStream,"BIG5")    '編碼
	For i = 0 To DataBufList.Size - 1
		DoEvents
		txtWrite.Writeline(DataBufList.Get(i))
	Next
	'txtWrite.WriteList(DataBufList)
	txtWrite.Flush
	txtWrite.Close
	outStream.Close
	Filescan(SaveAllDirName,ShortFileName)
End Sub
Sub IsArray(sArr As Object) As Boolean
	Try
		Dim R As Reflector
   		Dim atest() As Int
   		R.Target = sArr
   		atest = R.TargetRank
		If atest(0) > 1 Then Return True
   		Return False
	Catch
		WriteLog("Error",True,"","FileIO.log",LastException.Message)
		Return False
	End Try
End Sub

Public Sub SetWaterSave(DirName As String,FileName As String,LogWaterLevel As String, WaterRulerLength As String,MeasureWaterLevel As String,Deviation As String)
	Dim DateFormat As String = DateTime.DateFormat
	Try
		DateTime.DateFormat = "yyyyMM"
		If DirName <> "" Then DirName= "/" & DirName
		Dim DateStr As String = "/" & DateTime.Date(DateTime.Now)
		Dim AllDirName As String = SaveDir & DirName & DateStr
		If File.Exists(AllDirName,"") = False Then File.MakeDir(SaveDir,DirName & DateStr)
		Dim Bol As Boolean = File.Exists(AllDirName,FileName)
		Dim outStream As OutputStream
		Dim txtWrite As TextWriter
		outStream = File.OpenOutput(AllDirName,FileName,True)
		txtWrite.Initialize2(outStream,"BIG5")    '編碼
		DateTime.Dateformat = "yyyy/MM/dd HH:mm:ss"
		DateStr = DateTime.Date(DateTime.Now)
		If Bol = False Then txtWrite.WriteLine("yyyy/MM/dd HH:mm:ss,記錄器水位,水尺長度,人工水位,誤差" & Chr(13))
		txtWrite.WriteLine(DateStr & "," & LogWaterLevel & "," & WaterRulerLength & "," & MeasureWaterLevel & "," & Deviation & Chr(13))
		txtWrite.Flush
		txtWrite.Close
		outStream.Close
		Filescan(AllDirName,FileName)		
	Catch
		Log(LastException)
	End Try
	DateTime.DateFormat = DateFormat
End Sub
